makedefs revision 1.1.1.2 1 1.1 tron #!/bin/sh
2 1.1 tron
3 1.1 tron #++
4 1.1 tron # NAME
5 1.1 tron # makedefs 1
6 1.1 tron # SUMMARY
7 1.1 tron # makefile configuration utility
8 1.1 tron # SYNOPSIS
9 1.1 tron # \fBmake makefiles \fIname=value...\fR
10 1.1 tron # DESCRIPTION
11 1.1 tron # The \fBmakedefs\fR command identifies the compilation
12 1.1 tron # environment, and emits macro definitions on the standard output
13 1.1 tron # stream that can be prepended to template Makefiles.
14 1.1 tron #
15 1.1 tron # Default settings can be overruled by specifying them as
16 1.1 tron # environment variables. Use quotes if variables contain
17 1.1 tron # whitespace or shell meta characters.
18 1.1 tron # .IP \fBAUXLIBS=\fIobject_library...\fR
19 1.1 tron # Specifies one or more non-default object libraries.
20 1.1 tron # .IP \fBCC=\fIcompiler_command\fR
21 1.1 tron # Specifies a non-default compiler. On many systems, the default
22 1.1 tron # is \fBgcc\fR.
23 1.1 tron # .IP \fBCCARGS=\fIcompiler_arguments\fR
24 1.1 tron # Specifies non-default compiler arguments, for example, a non-default
25 1.1 tron # \fIinclude\fR directory.
26 1.1 tron # The following directives are special:
27 1.1 tron # .RS
28 1.1 tron # .IP \fB-DNO_DEVPOLL\fR
29 1.1 tron # Do not build with Solaris /dev/poll support.
30 1.1 tron # By default, /dev/poll support is compiled in on platforms that
31 1.1 tron # are known to support it.
32 1.1 tron # .IP \fB-DNO_EPOLL\fR
33 1.1 tron # Do not build with Linux EPOLL support.
34 1.1 tron # By default, EPOLL support is compiled in on platforms that
35 1.1 tron # are known to support it.
36 1.1 tron # .IP \fB-DNO_IPV6\fR
37 1.1 tron # Do not build with IPv6 support.
38 1.1 tron # By default, IPv6 support is compiled in on platforms that
39 1.1 tron # are known to have IPv6 support.
40 1.1 tron #
41 1.1 tron # Note: this directive is for debugging and testing only. It
42 1.1 tron # is not guaranteed to work on all platforms.
43 1.1 tron # .IP \fB-DNO_KQUEUE\fR
44 1.1 tron # Do not build with FreeBSD/NetBSD/OpenBSD/MacOSX KQUEUE support.
45 1.1 tron # By default, KQUEUE support is compiled in on platforms that
46 1.1 tron # are known to support it.
47 1.1 tron # .IP \fB-DNO_PCRE\fR
48 1.1 tron # Do not build with PCRE support.
49 1.1 tron # By default, PCRE support is compiled in when the \fBpcre-config\fR
50 1.1 tron # utility is installed.
51 1.1 tron # .IP \fB-DNO_SIGSETJMP\fR
52 1.1 tron # Use setjmp()/longjmp() instead of sigsetjmp()/siglongjmp().
53 1.1 tron # By default, Postfix uses sigsetjmp()/siglongjmp() when they
54 1.1 tron # appear to work.
55 1.1 tron # .RE
56 1.1 tron # .IP \fBDEBUG=\fIdebug_level\fR
57 1.1 tron # Specifies a non-default debugging level. The default is \fB-g\fR.
58 1.1 tron # Specify \fBDEBUG=\fR to turn off debugging.
59 1.1 tron # .IP \fBOPT=\fIoptimization_level\fR
60 1.1 tron # Specifies a non-default optimization level. The default is \fB-O\fR.
61 1.1 tron # Specify \fBOPT=\fR to turn off optimization.
62 1.1 tron # .IP \fBWARN=\fIwarning_flags\fR
63 1.1 tron # Specifies non-default gcc compiler warning options for use when
64 1.1 tron # "make" is invoked in a source subdirectory only.
65 1.1 tron # LICENSE
66 1.1 tron # .ad
67 1.1 tron # .fi
68 1.1 tron # The Secure Mailer license must be distributed with this software.
69 1.1 tron # AUTHOR(S)
70 1.1 tron # Wietse Venema
71 1.1 tron # IBM T.J. Watson Research
72 1.1 tron # P.O. Box 704
73 1.1 tron # Yorktown Heights, NY 10598, USA
74 1.1 tron #--
75 1.1 tron
76 1.1 tron # Emit system-dependent Makefile macro definitions to standard output.
77 1.1 tron
78 1.1 tron # Defaults for most sane systems
79 1.1 tron
80 1.1 tron RANLIB=ranlib
81 1.1 tron SYSLIBS=
82 1.1 tron AR=ar
83 1.1 tron ARFL=rv
84 1.1 tron
85 1.1 tron # Ugly function to make our error message more visible among the
86 1.1 tron # garbage that is output by some versions of make(1).
87 1.1 tron
88 1.1 tron # By now all shells must have functions.
89 1.1 tron
90 1.1 tron error() {
91 1.1 tron # Alas, tput(1) is not portable so we can't use visual effects.
92 1.1 tron echo "ATTENTION:" 1>&2;
93 1.1 tron echo "ATTENTION:" $* 1>&2;
94 1.1 tron echo "ATTENTION:" 1>&2;
95 1.1 tron exit 1
96 1.1 tron }
97 1.1 tron
98 1.1 tron case $# in
99 1.1 tron # Officially supported usage.
100 1.1 tron 0) SYSTEM=`(uname -s) 2>/dev/null`
101 1.1 tron RELEASE=`(uname -r) 2>/dev/null`
102 1.1 tron VERSION=`(uname -v) 2>/dev/null`
103 1.1 tron case "$VERSION" in
104 1.1 tron dcosx*) SYSTEM=$VERSION;;
105 1.1 tron esac;;
106 1.1 tron # Unsupported debug-only mode. Not suitable for cross-platform tests.
107 1.1 tron 2) SYSTEM="$1"; RELEASE="$2";;
108 1.1 tron *) echo usage: $0 [system release] 1>&2; exit 1;;
109 1.1 tron esac
110 1.1 tron
111 1.1 tron case "$SYSTEM.$RELEASE" in
112 1.1 tron SCO_SV.3.2) SYSTYPE=SCO5
113 1.1 tron # Use the native compiler by default
114 1.1 tron : ${CC="/usr/bin/cc -b elf"}
115 1.1 tron CCARGS="$CCARGS -DPIPES_CANT_FIONREAD $CCARGS"
116 1.1 tron SYSLIBS="-lsocket -ldbm"
117 1.1 tron RANLIB=echo
118 1.1 tron ;;
119 1.1 tron UnixWare.5*) SYSTYPE=UW7
120 1.1 tron # Use the native compiler by default
121 1.1 tron : ${CC=/usr/bin/cc}
122 1.1 tron RANLIB=echo
123 1.1 tron SYSLIBS="-lresolv -lsocket -lnsl"
124 1.1 tron ;;
125 1.1 tron UNIX_SV.4.2*) case "`uname -v`" in
126 1.1 tron 2.1*) SYSTYPE=UW21
127 1.1 tron # Use the native compiler by default
128 1.1 tron : ${CC=/usr/bin/cc}
129 1.1 tron RANLIB=echo
130 1.1 tron SYSLIBS="-lresolv -lsocket -lnsl -lc -L/usr/ucblib -lucb"
131 1.1 tron ;;
132 1.1 tron *) error "Seems to be UnixWare`uname -v`. Untested.";;
133 1.1 tron esac
134 1.1 tron ;;
135 1.1 tron FreeBSD.2*) SYSTYPE=FREEBSD2
136 1.1 tron ;;
137 1.1 tron FreeBSD.3*) SYSTYPE=FREEBSD3
138 1.1 tron ;;
139 1.1 tron FreeBSD.4*) SYSTYPE=FREEBSD4
140 1.1 tron ;;
141 1.1 tron FreeBSD.5*) SYSTYPE=FREEBSD5
142 1.1 tron ;;
143 1.1 tron FreeBSD.6*) SYSTYPE=FREEBSD6
144 1.1 tron ;;
145 1.1 tron FreeBSD.7*) SYSTYPE=FREEBSD7
146 1.1 tron ;;
147 1.1.1.2 tron FreeBSD.8*) SYSTYPE=FREEBSD8
148 1.1.1.2 tron ;;
149 1.1 tron OpenBSD.2*) SYSTYPE=OPENBSD2
150 1.1 tron ;;
151 1.1 tron OpenBSD.3*) SYSTYPE=OPENBSD3
152 1.1 tron ;;
153 1.1 tron OpenBSD.4*) SYSTYPE=OPENBSD4
154 1.1 tron ;;
155 1.1 tron ekkoBSD.1*) SYSTYPE=EKKOBSD1
156 1.1 tron ;;
157 1.1 tron NetBSD.1*) SYSTYPE=NETBSD1
158 1.1 tron ;;
159 1.1 tron NetBSD.2*) SYSTYPE=NETBSD2
160 1.1 tron ;;
161 1.1 tron NetBSD.3*) SYSTYPE=NETBSD3
162 1.1 tron ;;
163 1.1 tron NetBSD.4*) SYSTYPE=NETBSD4
164 1.1 tron ;;
165 1.1 tron BSD/OS.2*) SYSTYPE=BSDI2
166 1.1 tron ;;
167 1.1 tron BSD/OS.3*) SYSTYPE=BSDI3
168 1.1 tron ;;
169 1.1 tron BSD/OS.4*) SYSTYPE=BSDI4
170 1.1 tron ;;
171 1.1 tron OSF1.V[3-5].*) SYSTYPE=OSF1
172 1.1 tron # Use the native compiler by default
173 1.1 tron : ${CC=cc}
174 1.1 tron : ${DEBUG="-g3"}
175 1.1 tron case $RELEASE in
176 1.1 tron V[0-4].*) CCARGS="$CCARGS -DNO_IPV6";;
177 1.1 tron esac
178 1.1 tron ;;
179 1.1 tron SunOS.4*) SYSTYPE=SUNOS4
180 1.1 tron SYSLIBS=-lresolv
181 1.1 tron ;;
182 1.1 tron SunOS.5*) SYSTYPE=SUNOS5
183 1.1 tron RANLIB=echo
184 1.1 tron SYSLIBS="-lresolv -lsocket -lnsl"
185 1.1 tron # Stock awk breaks with >10 files.
186 1.1 tron test -x /usr/xpg4/bin/awk && AWK=/usr/xpg4/bin/awk
187 1.1 tron # Solaris 2.5 added usleep() and POSIX regular expressions
188 1.1 tron case $RELEASE in
189 1.1 tron 5.[0-4]) CCARGS="$CCARGS -DMISSING_USLEEP -DNO_POSIX_REGEXP";;
190 1.1 tron esac
191 1.1 tron # Solaris 8 added IPv6 and /dev/poll
192 1.1 tron case $RELEASE in
193 1.1 tron 5.[0-7]|5.[0-7].*) CCARGS="$CCARGS -DNO_IPV6 -DNO_DEVPOLL";;
194 1.1 tron esac
195 1.1 tron # Solaris 9 added closefrom(), futimesat() and /dev/*random
196 1.1 tron case $RELEASE in
197 1.1 tron 5.[0-8]|5.[0-8].*) CCARGS="$CCARGS -DNO_CLOSEFROM -DNO_DEV_URANDOM -DNO_FUTIMESAT";;
198 1.1 tron esac
199 1.1 tron # Work around broken str*casecmp(). Do it all here instead
200 1.1 tron # of having half the solution in the sys_defs.h file.
201 1.1 tron CCARGS="$CCARGS -Dstrcasecmp=fix_strcasecmp \
202 1.1 tron -Dstrncasecmp=fix_strncasecmp"
203 1.1 tron STRCASE="strcasecmp.o"
204 1.1 tron # Avoid common types of braindamage
205 1.1 tron case "$LD_LIBRARY_PATH" in
206 1.1 tron ?*) error "Don't set LD_LIBRARY_PATH";;
207 1.1 tron esac
208 1.1 tron case "${CC}" in
209 1.1 tron *" "*) ;;
210 1.1 tron *ucb*) error "Don't use /usr/ucb/cc or ucblib";;
211 1.1 tron cc*) case `which ${CC}` in
212 1.1 tron *ucb*) error "Don't use /usr/ucb/cc or ucblib";;
213 1.1 tron esac;;
214 1.1 tron esac
215 1.1 tron ;;
216 1.1 tron ULTRIX.4*) SYSTYPE=ULTRIX4
217 1.1 tron if [ -f /usr/local/lib/libdb.a ]; then
218 1.1 tron SYSLIBS="$SYSLIBS -ldb"
219 1.1 tron CCARGS="$CCARGS -DHAS_DB"
220 1.1 tron if [ -d /usr/local/include/db ]; then
221 1.1 tron CCARGS="$CCARGS -I/usr/local/include/db"
222 1.1 tron fi
223 1.1 tron fi
224 1.1 tron for l in syslog resolv; do
225 1.1 tron if [ -f /usr/local/lib/lib$l.a ]; then
226 1.1 tron SYSLIBS="$SYSLIBS -l$l"
227 1.1 tron fi
228 1.1 tron done
229 1.1 tron ;;
230 1.1 tron AIX.*) case "`uname -v`" in
231 1.1 tron 5) SYSTYPE=AIX5
232 1.1 tron case "$CC" in
233 1.1 tron cc|*/cc|xlc|*/xlc) CCARGS="$CCARGS -w -blibpath:/usr/lib:/lib:/usr/local/lib";;
234 1.1 tron esac
235 1.1 tron CCARGS="$CCARGS -D_ALL_SOURCE -DHAS_POSIX_REGEXP"
236 1.1 tron ;;
237 1.1 tron 4) SYSTYPE=AIX4
238 1.1 tron # How embarrassing...
239 1.1 tron case "$CC" in
240 1.1 tron cc|*/cc|xlc|*/xlc) OPT=; CCARGS="$CCARGS -w -blibpath:/usr/lib:/lib:/usr/local/lib";;
241 1.1 tron esac
242 1.1 tron CCARGS="$CCARGS -D_ALL_SOURCE -DHAS_POSIX_REGEXP"
243 1.1 tron ;;
244 1.1 tron 3) SYSTYPE=AIX3
245 1.1 tron # How embarrassing...
246 1.1 tron case "$CC" in
247 1.1 tron cc|*/cc|xlc|*/xlc) OPT=; CCARGS="$CCARGS -w";;
248 1.1 tron esac
249 1.1 tron CCARGS="$CCARGS -D_ALL_SOURCE"
250 1.1 tron ;;
251 1.1 tron *) error "Unknown AIX version: `uname -v`.";;
252 1.1 tron esac;;
253 1.1 tron # Tested with RedHat 3.03 on 20020729.
254 1.1 tron Linux.1*) SYSTYPE=LINUX1
255 1.1 tron SYSLIBS="-ldb"
256 1.1 tron ;;
257 1.1 tron Linux.2*) SYSTYPE=LINUX2
258 1.1 tron # Postfix no longer needs DB 1.85 compatibility
259 1.1 tron if [ -f /usr/include/db.h ]
260 1.1 tron then
261 1.1 tron : we are all set
262 1.1 tron elif [ -f /usr/include/db/db.h ]
263 1.1 tron then
264 1.1 tron CCARGS="$CCARGS -I/usr/include/db"
265 1.1 tron else
266 1.1 tron # No, we're not going to try db1 db2 db3 etc.
267 1.1 tron # On a properly installed system, Postfix builds
268 1.1 tron # by including <db.h> and by linking with -ldb
269 1.1 tron echo "No <db.h> include file found." 1>&2
270 1.1 tron echo "Install the appropriate db*-devel package first." 1>&2
271 1.1 tron echo "See the RELEASE_NOTES file for more information." 1>&2
272 1.1 tron exit 1
273 1.1 tron fi
274 1.1 tron # GDBM locks the DBM .pag file after open. This breaks postmap.
275 1.1 tron # if [ -f /usr/include/gdbm-ndbm.h ]
276 1.1 tron # then
277 1.1 tron # CCARGS="$CCARGS -DHAS_DBM -DPATH_NDBM_H='<gdbm-ndbm.h>'"
278 1.1 tron # GDBM_LIBS=gdbm
279 1.1 tron # elif [ -f /usr/include/gdbm/ndbm.h ]
280 1.1 tron # then
281 1.1 tron # CCARGS="$CCARGS -DHAS_DBM -DPATH_NDBM_H='<gdbm/ndbm.h>'"
282 1.1 tron # GDBM_LIBS=gdbm
283 1.1 tron # fi
284 1.1 tron SYSLIBS="-ldb"
285 1.1 tron for name in nsl resolv $GDBM_LIBS
286 1.1 tron do
287 1.1 tron for lib in /usr/lib64 /lib64 /usr/lib /lib
288 1.1 tron do
289 1.1 tron test -e $lib/lib$name.a -o -e $lib/lib$name.so && {
290 1.1 tron SYSLIBS="$SYSLIBS -l$name"
291 1.1 tron break
292 1.1 tron }
293 1.1 tron done
294 1.1 tron done
295 1.1 tron # Kernel 2.4 added IPv6
296 1.1 tron case "$RELEASE" in
297 1.1 tron 2.[0-3].*) CCARGS="$CCARGS -DNO_IPV6";;
298 1.1 tron esac
299 1.1 tron # Kernel 2.6 added EPOLL
300 1.1 tron case "$RELEASE" in
301 1.1 tron 2.[0-5].*) CCARGS="$CCARGS -DNO_EPOLL";;
302 1.1 tron # Workaround for retarded libc
303 1.1 tron 2.6.*) trap 'rm -f makedefs.test makedefs.test.[co]' 1 2 3 15
304 1.1 tron cat >makedefs.test.c <<'EOF'
305 1.1 tron #include <sys/types.h>
306 1.1 tron #include <sys/epoll.h>
307 1.1 tron #include <errno.h>
308 1.1 tron #include <stdio.h>
309 1.1 tron #include <stdlib.h>
310 1.1 tron
311 1.1 tron int main(int argc, char **argv)
312 1.1 tron {
313 1.1 tron int epoll_handle;
314 1.1 tron
315 1.1 tron if ((epoll_handle = epoll_create(1)) < 0) {
316 1.1 tron perror("epoll_create");
317 1.1 tron exit(1);
318 1.1 tron }
319 1.1 tron exit(0);
320 1.1 tron }
321 1.1 tron EOF
322 1.1 tron ${CC-gcc} -o makedefs.test makedefs.test.c || exit 1
323 1.1 tron ./makedefs.test 2>/dev/null ||
324 1.1 tron CCARGS="$CCARGS -DNO_EPOLL"
325 1.1 tron rm -f makedefs.test makedefs.test.[co];;
326 1.1 tron esac
327 1.1 tron ;;
328 1.1 tron GNU.0*|GNU/kFreeBSD.[567]*)
329 1.1 tron SYSTYPE=GNU0
330 1.1 tron # Postfix no longer needs DB 1.85 compatibility
331 1.1 tron if [ -f /usr/include/db.h ]
332 1.1 tron then
333 1.1 tron : we are all set
334 1.1 tron elif [ -f /usr/include/db/db.h ]
335 1.1 tron then
336 1.1 tron CCARGS="$CCARGS -I/usr/include/db"
337 1.1 tron else
338 1.1 tron # No, we're not going to try db1 db2 db3 etc.
339 1.1 tron # On a properly installed system, Postfix builds
340 1.1 tron # by including <db.h> and by linking with -ldb
341 1.1 tron echo "No <db.h> include file found." 1>&2
342 1.1 tron echo "Install the appropriate db*-devel package first." 1>&2
343 1.1 tron echo "See the RELEASE_NOTES file for more information." 1>&2
344 1.1 tron exit 1
345 1.1 tron fi
346 1.1 tron SYSLIBS="-ldb"
347 1.1 tron for name in nsl resolv
348 1.1 tron do
349 1.1 tron for lib in /usr/lib64 /lib64 /usr/lib /lib
350 1.1 tron do
351 1.1 tron test -e $lib/lib$name.a -o -e $lib/lib$name.so && {
352 1.1 tron SYSLIBS="$SYSLIBS -l$name"
353 1.1 tron break
354 1.1 tron }
355 1.1 tron done
356 1.1 tron done
357 1.1 tron case "`uname -s`" in
358 1.1 tron GNU)
359 1.1 tron # currently no IPv6 support on Hurd
360 1.1 tron CCARGS="$CCARGS -DNO_IPV6"
361 1.1 tron ;;
362 1.1 tron esac
363 1.1 tron ;;
364 1.1 tron IRIX*.5.*) SYSTYPE=IRIX5
365 1.1 tron # Use the native compiler by default
366 1.1 tron : ${CC=cc} ${DEBUG="-g3"}
367 1.1 tron RANLIB=echo
368 1.1 tron ;;
369 1.1 tron IRIX*.6.*) SYSTYPE=IRIX6
370 1.1 tron # Use the native compiler by default, and allow nested comments.
371 1.1 tron : ${CC="cc -woff 1009,1116,1412"}
372 1.1 tron RANLIB=echo
373 1.1 tron ;;
374 1.1 tron HP-UX.A.09.*) SYSTYPE=HPUX9
375 1.1 tron SYSLIBS=-ldbm
376 1.1 tron CCARGS="$CCARGS -DMISSING_USLEEP"
377 1.1 tron if [ -f /usr/lib/libdb.a ]; then
378 1.1 tron CCARGS="$CCARGS -DHAS_DB"
379 1.1 tron SYSLIBS="$SYSLIBS -ldb"
380 1.1 tron fi
381 1.1 tron ;;
382 1.1 tron HP-UX.B.10.*) SYSTYPE=HPUX10
383 1.1 tron CCARGS="$CCARGS `nm /usr/lib/libc.a 2>/dev/null |
384 1.1 tron (grep usleep >/dev/null || echo '-DMISSING_USLEEP')`"
385 1.1 tron if [ -f /usr/lib/libdb.a ]; then
386 1.1 tron CCARGS="$CCARGS -DHAS_DB"
387 1.1 tron SYSLIBS=-ldb
388 1.1 tron fi
389 1.1 tron ;;
390 1.1 tron HP-UX.B.11.*) SYSTYPE=HPUX11
391 1.1 tron SYSLIBS=-lnsl
392 1.1 tron if [ -f /usr/lib/libdb.a ]; then
393 1.1 tron CCARGS="$CCARGS -DHAS_DB"
394 1.1 tron SYSLIBS="$SYSLIBS -ldb"
395 1.1 tron fi
396 1.1 tron ;;
397 1.1 tron ReliantUNIX-?.5.43) SYSTYPE=ReliantUnix543
398 1.1 tron RANLIB=echo
399 1.1 tron SYSLIBS="-lresolv -lsocket -lnsl"
400 1.1 tron ;;
401 1.1 tron Darwin.*) SYSTYPE=MACOSX
402 1.1 tron # Use the native compiler by default
403 1.1 tron : ${CC=cc}
404 1.1 tron # Darwin > 1.3 uses awk and flat_namespace
405 1.1 tron case $RELEASE in
406 1.1 tron 1.[0-3]) AWK=gawk;;
407 1.1 tron *) AWK=awk
408 1.1 tron SYSLIBS=-flat_namespace;;
409 1.1 tron esac
410 1.1 tron # Darwin 7 adds IPv6 support, BIND_8_COMPAT, NO_NETINFO
411 1.1 tron case $RELEASE in
412 1.1 tron [1-6].*) CCARGS="$CCARGS -DNO_IPV6";;
413 1.1 tron *) CCARGS="$CCARGS -DBIND_8_COMPAT -DNO_NETINFO";;
414 1.1 tron esac
415 1.1 tron # kqueue and/or poll are broken up to and including MacOS X 10.5
416 1.1 tron CCARGS="$CCARGS -DNO_KQUEUE"
417 1.1 tron # # Darwin 8.11.1 has kqueue support, but let's play safe
418 1.1 tron # case $RELEASE in
419 1.1 tron # [1-8].*) CCARGS="$CCARGS -DNO_KQUEUE";;
420 1.1 tron # *) trap 'rm -f makedefs.test makedefs.test.[co]' 1 2 3 15
421 1.1 tron # cat >makedefs.test.c <<'EOF'
422 1.1 tron #/* Adapted from libevent. */
423 1.1 tron #
424 1.1 tron ##include <sys/types.h>
425 1.1 tron ##include <sys/event.h>
426 1.1 tron ##include <sys/time.h>
427 1.1 tron ##include <string.h>
428 1.1 tron ##include <stdlib.h>
429 1.1 tron ##include <stdio.h>
430 1.1 tron #
431 1.1 tron ##ifndef EV_SET
432 1.1 tron ##define EV_SET(kp, id, fi, fl, ffl, da, ud) do { \
433 1.1 tron # struct kevent *__kp = (kp); \
434 1.1 tron # __kp->ident = (id); \
435 1.1 tron # __kp->filter = (fi); \
436 1.1 tron # __kp->flags = (fl); \
437 1.1 tron # __kp->fflags = (ffl); \
438 1.1 tron # __kp->data = (da); \
439 1.1 tron # __kp->udata = (ud); \
440 1.1 tron # } while(0)
441 1.1 tron ##endif
442 1.1 tron #
443 1.1 tron #int main(int argc, char **argv)
444 1.1 tron #{
445 1.1 tron # int kq;
446 1.1 tron # struct kevent test_change;
447 1.1 tron # struct kevent test_result;
448 1.1 tron #
449 1.1 tron # if ((kq = kqueue()) < 0) {
450 1.1 tron # perror("kqueue");
451 1.1 tron # exit(1);
452 1.1 tron # }
453 1.1 tron ##define TEST_FD (-1)
454 1.1 tron #
455 1.1 tron # EV_SET(&test_change, TEST_FD, EVFILT_READ, EV_ADD, 0, 0, 0);
456 1.1 tron # if (kevent(kq,
457 1.1 tron # &test_change, sizeof(test_change) / sizeof(struct kevent),
458 1.1 tron # &test_result, sizeof(test_result) / sizeof(struct kevent),
459 1.1 tron # (struct timespec *) 0) != 1 ||
460 1.1 tron # test_result.ident != TEST_FD ||
461 1.1 tron # test_result.flags != EV_ERROR) {
462 1.1 tron # fprintf(stderr, "Error: kevent reports errors incorrectly\n");
463 1.1 tron # exit(1);
464 1.1 tron # }
465 1.1 tron # exit(0);
466 1.1 tron #}
467 1.1 tron #EOF
468 1.1 tron # $CC -o makedefs.test makedefs.test.c || exit 1
469 1.1 tron # ./makedefs.test 2>/dev/null ||
470 1.1 tron # CCARGS="$CCARGS -DNO_KQUEUE"
471 1.1 tron # rm -f makedefs.test makedefs.test.[co];;
472 1.1 tron # esac
473 1.1 tron ;;
474 1.1 tron dcosx.1*) SYSTYPE=DCOSX1
475 1.1 tron RANLIB=echo
476 1.1 tron SYSLIBS="-lresolv -lsocket -lnsl -lc -lrpcsvc -L/usr/ucblib -lucb"
477 1.1 tron ;;
478 1.1 tron
479 1.1 tron ".") if [ -d /NextApps ]; then
480 1.1 tron SYSTYPE=`hostinfo | sed -n \
481 1.1 tron 's/^.*NeXT Mach 3.*$/NEXTSTEP3/;/NEXTSTEP3/{p;q;}'`
482 1.1 tron if [ "$SYSTYPE" = "" ]; then
483 1.1 tron SYSTYPE=`hostinfo | sed -n \
484 1.1 tron 's/^.*NeXT Mach 4.*$/OPENSTEP4/;/OPENSTEP4/{p;q;}'`
485 1.1 tron fi
486 1.1 tron : ${CC=cc}
487 1.1 tron RANLIB="sleep 5; ranlib"
488 1.1 tron else
489 1.1 tron error "Unable to determine your system type."
490 1.1 tron fi
491 1.1 tron ;;
492 1.1 tron *) error "Unknown system type: $SYSTEM $RELEASE";;
493 1.1 tron esac
494 1.1 tron
495 1.1 tron #
496 1.1 tron # sigsetjmp()/siglongjmp() can be "better" than setjmp()/longjmp()
497 1.1 tron # if used wisely (that is: almost never, just like signals).
498 1.1 tron # Unfortunately some implementations have been buggy in the past.
499 1.1 tron #
500 1.1 tron case "$CCARGS" in
501 1.1 tron *-DNO_SIGSETJMP*) ;;
502 1.1 tron *) trap 'rm -f makedefs.test makedefs.test.[co]' 1 2 3 15
503 1.1 tron cat >makedefs.test.c <<'EOF'
504 1.1 tron #include <setjmp.h>
505 1.1 tron #include <stdlib.h>
506 1.1 tron #include <stdio.h>
507 1.1 tron
508 1.1 tron static int count = 0;
509 1.1 tron
510 1.1 tron int main(int argc, char **argv)
511 1.1 tron {
512 1.1 tron sigjmp_buf env;
513 1.1 tron int retval;
514 1.1 tron
515 1.1 tron switch (retval = sigsetjmp(env, 1)) {
516 1.1 tron case 0:
517 1.1 tron siglongjmp(env, 12345);
518 1.1 tron case 12345:
519 1.1 tron break;
520 1.1 tron default:
521 1.1 tron fprintf(stderr, "Error: siglongjmp ignores second argument\n");
522 1.1 tron exit(1);
523 1.1 tron }
524 1.1 tron
525 1.1 tron switch (retval = sigsetjmp(env, 1)) {
526 1.1 tron case 0:
527 1.1 tron if (count++ > 0) {
528 1.1 tron fprintf(stderr, "Error: not overriding siglongjmp(env, 0)\n");
529 1.1 tron exit(1);
530 1.1 tron }
531 1.1 tron siglongjmp(env, 0);
532 1.1 tron case 1:
533 1.1 tron break;
534 1.1 tron default:
535 1.1 tron fprintf(stderr, "Error: overriding siglongjmp(env, 0) with %d\n",
536 1.1 tron retval);
537 1.1 tron exit(1);
538 1.1 tron }
539 1.1 tron exit(0);
540 1.1 tron }
541 1.1 tron EOF
542 1.1 tron ${CC-gcc} -o makedefs.test makedefs.test.c || exit 1
543 1.1 tron ./makedefs.test 2>/dev/null ||
544 1.1 tron CCARGS="$CCARGS -DNO_SIGSETJMP"
545 1.1 tron rm -f makedefs.test makedefs.test.[co]
546 1.1 tron esac
547 1.1 tron
548 1.1 tron #
549 1.1 tron # OpenSSL has no configuration query utility, but we don't try to
550 1.1 tron # guess. We assume includes in /usr/include/openssl and libraries in
551 1.1 tron # /usr/lib, or in their /usr/local equivalents. If the OpenSSL files
552 1.1 tron # are in a non-standard place, their locations need to be specified.
553 1.1 tron #
554 1.1 tron #case "$CCARGS" in
555 1.1 tron # *-DUSE_TLS*) ;;
556 1.1 tron # *-DNO_TLS*) ;;
557 1.1 tron # *) CCARGS="$CCARGS -DUSE_TLS"
558 1.1 tron # AUXLIBS="$AUXLIBS -lssl -lcrypto"
559 1.1 tron # ;;
560 1.1 tron #esac
561 1.1 tron
562 1.1 tron #
563 1.1 tron # PCRE 3.x has a pcre-config utility so we don't have to guess.
564 1.1 tron #
565 1.1 tron case "$CCARGS" in
566 1.1 tron *-DHAS_PCRE*) ;;
567 1.1 tron *-DNO_PCRE*) ;;
568 1.1 tron *) pcre_cflags=`(pcre-config --cflags) 2>/dev/null` &&
569 1.1 tron pcre_libs=`(pcre-config --libs) 2>/dev/null` && {
570 1.1 tron CCARGS="$CCARGS -DHAS_PCRE $pcre_cflags"
571 1.1 tron AUXLIBS="$AUXLIBS $pcre_libs"
572 1.1 tron }
573 1.1 tron ;;
574 1.1 tron esac
575 1.1 tron
576 1.1 tron # Defaults that can be overruled (make makefiles CC=cc OPT=-O6 DEBUG=)
577 1.1 tron # Disable optimizations by default when compiling for Purify. Disable
578 1.1 tron # optimizations by default with gcc 2.8, until the compiler is known to
579 1.1 tron # be OK. Those who dare can still overrule this (make makefiles OPT=-O).
580 1.1 tron
581 1.1 tron case "$CC" in
582 1.1 tron *purify*) : ${OPT=};;
583 1.1 tron */gcc|gcc) case `$CC -v` in
584 1.1 tron "gcc version 2.8"*) : ${OPT=};;
585 1.1 tron esac;;
586 1.1 tron *CC) error "Don't use CC. That's the C++ compiler";;
587 1.1 tron *) : ${OPT='-O'};;
588 1.1 tron esac
589 1.1 tron #
590 1.1 tron # "gcc -W" 3.4.2 no longer reports functions that fail to return a
591 1.1 tron # result. Use "gcc -Wall -Wno-comment" instead. We'll figure out
592 1.1 tron # later if the other -Wmumble options are really redundant. Having
593 1.1 tron # een burned once by a compiler that lies about what warnings it
594 1.1 tron # produces, not taking that chance again.
595 1.1 tron
596 1.1 tron : ${CC='gcc $(WARN)'} ${OPT='-O'} ${DEBUG='-g'} ${AWK=awk} \
597 1.1 tron ${WARN='-Wall -Wno-comment -Wformat -Wimplicit -Wmissing-prototypes \
598 1.1 tron -Wparentheses -Wstrict-prototypes -Wswitch -Wuninitialized \
599 1.1 tron -Wunused -Wno-missing-braces'}
600 1.1 tron
601 1.1 tron export SYSTYPE AR ARFL RANLIB SYSLIBS CC OPT DEBUG AWK OPTS
602 1.1 tron
603 1.1 tron # Snapshot only.
604 1.1 tron #CCARGS="$CCARGS -DSNAPSHOT"
605 1.1 tron
606 1.1 tron # Non-production: needs thorough testing, or major changes are still
607 1.1 tron # needed before the code stabilizes.
608 1.1 tron #CCARGS="$CCARGS -DNONPROD"
609 1.1 tron
610 1.1 tron sed 's/ / /g' <<EOF
611 1.1 tron SYSTYPE = $SYSTYPE
612 1.1 tron AR = $AR
613 1.1 tron ARFL = $ARFL
614 1.1 tron RANLIB = $RANLIB
615 1.1 tron SYSLIBS = $AUXLIBS $SYSLIBS
616 1.1 tron CC = $CC $CCARGS
617 1.1 tron OPT = $OPT
618 1.1 tron DEBUG = $DEBUG
619 1.1 tron AWK = $AWK
620 1.1 tron STRCASE = $STRCASE
621 1.1 tron EXPORT = AUXLIBS='$AUXLIBS' CCARGS='$CCARGS' OPT='$OPT' DEBUG='$DEBUG'
622 1.1 tron WARN = $WARN
623 1.1 tron EOF
624